IMPLEMENTATION MODULE CALCSTACK;

IMPORT STACKS;
IMPORT ITEMS;

IMPORT RSTACKELEMENT;


TYPE CalcStack = STACKS.Stack;


   PROCEDURE Create (VAR C : CalcStack);
   BEGIN
      C := STACKS.Create ()
   END Create;


   PROCEDURE Push (VAR C : CalcStack; S : RSTACKELEMENT.StackElement);
   BEGIN
      STACKS.Push (C,ITEMS.Item(S))
   END Push;


   PROCEDURE Pop (VAR C : CalcStack); 
   BEGIN
      STACKS.Pop (C)
   END Pop;


   PROCEDURE Top (C : CalcStack) : RSTACKELEMENT.StackElement;
   VAR StEl : RSTACKELEMENT.StackElement;
   BEGIN
     StEl := RSTACKELEMENT.StackElement (STACKS.Top (C));
     CASE RSTACKELEMENT.GetNumberType (StEl) OF
        RSTACKELEMENT.integers :
              RETURN RSTACKELEMENT.CreateInteger(
                 RSTACKELEMENT.GetInteger(StEl))
     |  RSTACKELEMENT.reals :
              RETURN RSTACKELEMENT.CreateReal(
                 RSTACKELEMENT.GetReal(StEl))
     END (* CASE *);
   END Top;


   PROCEDURE Destroy (VAR C : CalcStack);
   BEGIN
       STACKS.Destroy (C)
   END Destroy;


   PROCEDURE IsEmpty (C : CalcStack) : BOOLEAN;
   BEGIN
      RETURN STACKS.IsEmpty (C)
   END IsEmpty;


END CALCSTACK.
