IMPLEMENTATION MODULE RSTACKINOUT;

FROM InOut
   IMPORT WriteString, Write, WriteLn, ReadString, WriteInt;

FROM Strings
   IMPORT Pos, Length;

FROM RealConversions
   IMPORT StringToReal, RealToString;

FROM NumberConversion
   IMPORT StringToInt;

FROM RSTACKELEMENT
  IMPORT StackElement, Operators, CreateOperator, CreateInteger, 
         CreateReal, IsInteger, IsOperator, GetInteger,
         GetReal, GetOperator;

FROM ERRORHANDLER IMPORT ErrorHandler;

FROM STACKINOUTEXCEPTIONS IMPORT Exit, Warning;


CONST ModuleID = "RSTACKINOUT";

TYPE charSet = SET OF CHAR;


PROCEDURE Input (VAR s : StackElement);
CONST ProcID = "Input";
VAR okay, valid : BOOLEAN;
    S           : ARRAY [0..12] OF CHAR;
    IntNum      : INTEGER;
    RealNum     : REAL;
BEGIN
   valid := FALSE;
   WHILE NOT valid DO
      WriteString ("Input ('=' to stop)? ");
      ReadString (S); WriteLn;
      IF (Length (S) = 1) & 
         (S [0] IN charSet{'+','-','*','/','='}) THEN
         s := CreateOperator (S [0]);
         valid := TRUE
      ELSE
         IF Pos ('.',S) <= HIGH (S) THEN
            StringToReal (S,RealNum,okay);
            s := CreateReal (RealNum);
            valid := okay;
            IF NOT valid THEN
               ErrorHandler (ModuleID,ProcID,1,Warning)
            END (* IF *)
         ELSE
            StringToInt (S,IntNum,okay);
            s := CreateInteger (IntNum);
            valid := okay;
            IF NOT valid THEN
               ErrorHandler (ModuleID,ProcID,2,Warning)
            END (* IF *)
         END (* IF *)
      END (* IF *)
   END (* WHILE *)
END Input;

PROCEDURE Output (s : StackElement);
CONST ProcID = "Output";
VAR okay      : BOOLEAN;
    NumString : ARRAY [0..12] OF CHAR;
    IntNum    : INTEGER;
    RealNum   : REAL;
    Opr       : Operators;
BEGIN
   IF IsOperator (s) THEN
      Opr := GetOperator (s);
      CASE Opr OF
         add : Write ("+")
      |  sub : Write ("-")
      |  mul : Write ("*")
      |  div : Write ("/")
      |  res : Write ("=")
      ELSE
      END (* CASE *);
      Write (" ")
   ELSIF IsInteger (s) THEN
      IntNum := GetInteger (s);
      WriteInt (IntNum,8)
   ELSE
      RealNum := GetReal (s);
      RealToString (RealNum,3,13,NumString,okay);
      WriteString (NumString);
      IF NOT okay THEN ErrorHandler (ModuleID,ProcID,3,Exit) END (*IF *)
   END (* IF *);
   WriteLn
END Output;


END RSTACKINOUT.
