IMPLEMENTATION MODULE STACKS;

IMPORT ITEMS;

IMPORT DLISTS;

FROM ERRORHANDLER 
   IMPORT ErrorHandler;

FROM STACKSEXCEPTIONS
   IMPORT Exit;

FROM Storage
   IMPORT Available;

FROM SYSTEM IMPORT SIZE;


CONST ModuleID = "STACKS";

TYPE Stack = DLISTS.List;



PROCEDURE Create () : Stack;
BEGIN
   RETURN DLISTS.Create ()
END Create;


PROCEDURE Destroy (VAR S : Stack);
CONST ProcID = "Destroy";
BEGIN
   IF NOT DLISTS.IsEmpty (S) THEN
      DLISTS.Destroy (S)
   ELSE
      ErrorHandler (ModuleID,ProcID,1,Exit)
   END (* IF *)
END Destroy;


PROCEDURE Copy (    theStack : Stack;
                VAR toStack  : Stack);
BEGIN
   DLISTS.Copy (theStack,toStack)
END Copy;


PROCEDURE Push (VAR S : Stack;
                    I : ITEMS.Item);
CONST ProcID = "Push";
BEGIN
   IF Available (SIZE(ITEMS.Item)) THEN
      IF DLISTS.IsEmpty (S) THEN
        S := DLISTS.SetList (I)
      ELSE
        DLISTS.Insert (S,I)
      END (* IF *)
   ELSE
      ErrorHandler (ModuleID,ProcID,2,Exit)
   END (* IF *)
END Push;


PROCEDURE Pop (VAR S : Stack);
CONST ProcID = "Pop";
BEGIN
   IF NOT DLISTS.IsEmpty (S) THEN
      DLISTS.Clear (S)
   ELSE
      ErrorHandler (ModuleID,ProcID,3,Exit)
   END (* IF *)
END Pop;


PROCEDURE Top (S : Stack) : ITEMS.Item;
CONST ProcID = "Top";
BEGIN
   IF NOT DLISTS.IsEmpty (S) THEN
      RETURN DLISTS.GetItem (S)
   ELSE
      ErrorHandler (ModuleID,ProcID,2,Exit)
   END (* IF *)
END Top;


PROCEDURE DepthOf (S : Stack) : CARDINAL;
BEGIN
   RETURN DLISTS.LengthOf (S)
END DepthOf;


PROCEDURE IsEmpty (S : Stack) : BOOLEAN;
BEGIN
   RETURN DLISTS.IsEmpty (S)
END IsEmpty;

BEGIN
   NullStack := DLISTS.NullList
END STACKS.
